//------------------------------------------------------------------------------
// perimeter.c - единица компиляции, вбирающая функции вычисления периметра
//------------------------------------------------------------------------------

#include "extdata.h"

// Вычисление периметра прямоугольника
double PerimeterRectangle(void *r) {
    return 2.0 * (*((int*)r) + *((int*)(r+intSize)));
}

// Вычисление периметра треугольника
double PerimeterTriangle(void *t) {
    return (double)(*((int*)t) +
            *((int*)(t+intSize)) +
            *((int*)(t+2*intSize)));
}

// Вычисление периметра фигуры
double PerimeterShape(void *s) {
    int k = *((int*)s);
    if(k == RECTANGLE) {
        return PerimeterRectangle(s+intSize);
    }
    else if(k == TRIANGLE) {
        return PerimeterTriangle(s+intSize);
    }
    else {
        return 0.0;
    }
}

// Вычисление суммы периметров всех фигур в контейнере
double PerimeterSumContainer(void *c, int len) {
    double sum = 0.0;
    void *tmp = c;
    for(int i = 0; i < len; i++) {
        sum += PerimeterShape(tmp);
        tmp = tmp + shapeSize;
    }
    return sum;
}
